/*

University of Sao Paulo - Institute of Mathematics and Computer Science ( ICMC - USP )
Computer Graphics - SCC 0250
Developer (PAE): Vinicius R. P. Borges
Profa: Maria Cristina Ferreira de Oliveira

Codigo 4 - Aula de Laboratorio 2 - 28/09/2012
CODE 4 - Lab 2

> Para compilar este codigo, execute no terminal do Linux - To compile this code, type the following command on Linux Terminal

# gcc ordemTransfGeom.c  -lX11 -lglut -lGL -lGLU -lm -o ordemTransfGeom

Para executar o codigo, digite - To run this code, type:

# ./ordemTransfGeom


ATENÇÃO: Para a correta utilizacao do codigo,
         siga as instrucoes contidas na funcao DrawGLScene
         para seu correto funcionamento e entendimento
*/

#include <stdio.h>
#include <GL/glut.h>
#include <stdlib.h>

//Identificador de janela
int window;

void InitGL(int Width, int Height){
     
     // Coloca a cor branca como fundo da tela
     glClearColor(1.0f,1.0f,1.0f,0.0f);
     
     // Carrega a matriz de projecao
     glMatrixMode(GL_PROJECTION);
     
     // Define uma projecao ortogonal que mapeia objetos
     // do sistema de coordenadas do mundo para o sistema
     // de coordenadas da tela
     gluOrtho2D(-1.0,1.0,-1.0,1.0);
}

// Funcao que desenha um triangulo na tela
void desenhaTriangulo(){
     
     glBegin(GL_TRIANGLES);
            glVertex2f(-0.1f,-0.1f);
            glVertex2f(0.1f,-0.1f);
            glVertex2f(0.0f,0.2f);
     glEnd();     
}

// Funcao que desenha a cena grafica na tela
void DrawGLScene(){

     // Muda para o sistema de coordenadas do modelo adotado
     glMatrixMode(GL_MODELVIEW);
     
     // Inicializa a matriz de transformacoes como identidade
     glLoadIdentity();
     
     // Limpa a tela e o depth buffer
     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
     
     // Ajusta a cor do objeto
     glColor3f(0.0,0.4,0.2);
     
     /*  ----- SITUACAO 1 ----- 

     1) Primeiro translada em 0.5f de tela com dimensoes 2.0f x 2.0f;
     2) Depois rotaciona em 108o graus em relacao ao eixo z;

     Descomente os dois comandos abaixo para habilitar a SITUACAO 1
     Comente os dois comandos da SITUACAO 2 para desabilita-la*/
     
     // Rotacao
     glRotatef(180.0f,0.0f,0.0f,1.0f);
     
     // Translacao
     glTranslatef(0.5f,0.0f,0.0f);
     
     /*  ----- SITUACAO 2 -----
     
     Descomente os dois comandos abaixo para habilitar a SITUACAO 2
     Comente os dois comandos da SITUACAO 1 para desabilita-la
     
     1) Primeiro rotaciona em 108o graus em relacao ao eixo z;
     2) Depois translada em 0.5f de tela com dimensoes 2.0f x 2.0f;
     
     
     
     // Translacao
     glTranslatef(0.5f,0.0f,0.0f);   
     
     // Rotacao
     glRotatef(180.0f,0.0f,0.0f,1.0f);*/
     
     // Desenha um objeto
     desenhaTriangulo();
     
     // Executa os comandos openGL o mais rapido possivel
     glFlush();
     
}

// Funcao que trata os eventos do teclado
void keyboard(unsigned char key, int x, int y){
     
     // Se usuario apertar a tecla z, o programa eh encerrado
     if(key == 'z'){
            glutDestroyWindow(window);
            exit(0);
     }
     
}

// Funcao principal
main(int argc, char *argv[])
{
         // Inicializacao da glut
         glutInit(&argc,argv);
         
         // Define os modos de operacao da GLUT
         glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);
         
         // Tamanho da janela do Glut
         glutInitWindowSize(640,480);
         
         // Posicao inicial da janela Glut na tela
         glutInitWindowPosition(0,0);
         
         // Criacao da janela Glut
         window = glutCreateWindow("Ordem de Transformacoes Geometricas");
         
         // Iniciar o ambiente grafico
         InitGL(640,480);
         
         // Funcoes do teclado
         glutKeyboardFunc(keyboard);
         
         // Desenha a cena grafica na tela
         glutDisplayFunc(DrawGLScene);
         
         // Loop de atualizacao na tela
         glutMainLoop();
         
         return 0;
}


